<?php
/**
 * Created by PhpStorm.
 * User: heyu
 * Date: 2019-05-16
 * Time: 14:31
 */
namespace kwy\mybank;


use kwy\mybank\request\MybankApi;

class MybankNotify extends MybankApi
{

    /**
     * 验签并生成mybankPayOrder
     * @param string $xml
     * @return MybankPayOrder
     * @throws \Exception
     */
    public function payNotify($xml){
        $ret=$this->verifyXmlSign($xml);
        if ($ret==false){
            throw new \Exception('验签失败');
        }
        libxml_disable_entity_loader(true);
        $post_arr=json_decode(json_encode(simplexml_load_string($xml,null,LIBXML_NOCDATA)),true);
        $pay_no=$post_arr['request']['body']['OutTradeNo'];
        $result=new MybankPayOrder($post_arr['request']['body']);
        $result->setReqHead($post_arr['request']['head']);
        return $result;
    }


    /**
     * @param array $head 传入的head
     * @param bool $status true表示正常返回 false 返回异常
     * @param string $errmsg
     * @return string
     */
    public function genResponseXml($head,$status,$errmsg=""){
        $respon_arr=[
            'document'=>[
                'response'=>[
                    'head'=>[
                        'Version'=>$head['Version'],
                        'Appid'=>$head['Appid'],
                        'Function'=>$head['Function'],
                        'RespTime'=>date('YmdHis'),
                        'RespTimeZone'=>'UTC+8',
                        'ReqMsgId'=>$head['ReqMsgId'],
                        'Reserve'=>'',
                        'SignType'=>'RSA',
                        'InputCharset'=>'UTF-8',
                    ],
                    'body'=>[
                        'RespInfo'=>[
                            'ResultStatus'=>$status?'S':'F',
                            'ResultCode'=>'0000',
                            'ResultMg'=>$status?'成功':$errmsg,
                        ],
                    ],
                ],
            ],
        ];
        $xml_unsigned=$this->array2Xml($respon_arr);
        $xml_signed=$this->signXml($xml_unsigned);
        return $xml_signed;
    }
}